import java.io.*;
import java.util.Scanner;

public class Graph
{

    private static int A = 0;
    private static int B = 0;

    public Graph()
    {
    }

    public static void main(String args[])
    {
        int q = 0;
        int w = 0;
        int v = 0;
        FileInputStream FIS = null;
        try
        {
            FIS = new FileInputStream("graph.in");
        }
        catch(FileNotFoundException e)
        {
            e.printStackTrace();
        }
        Scanner scan = new Scanner(FIS);
        A = scan.nextInt();
        B = scan.nextInt();
        int in[][] = new int[A][A];
        int out[][] = new int[A][A];
        for(; v < B; v++)
        {
            q = scan.nextInt() - 1;
            w = scan.nextInt() - 1;
            if(q > w)
            {
                in[w][q] = scan.nextInt();
                out[w][q] = v + 1;
            } else
            {
                in[q][w] = scan.nextInt();
                out[q][w] = v + 1;
            }
        }

        try
        {
            FIS.close();
        }
        catch(IOException e)
        {
            e.printStackTrace();
        }
        scan.close();
        int U[] = new int[A];
        int E[][] = new int[B][3];
        int F[][] = new int[A - 1][3];
        int edge_number = 0;
        int edge_next = 0;
        int k = 0;
        for(int i = 0; i < A; i++)
        {
            for(int j = 0; j < A; j++)
            {
                if(j > i && in[i][j] > 0)
                {
                    E[k][0] = i;
                    E[k][1] = j;
                    E[k][2] = in[i][j];
                    k++;
                }
            }

        }

        for(int i = B - 1; i > 0; i--)
        {
            for(int j = 0; j < i; j++)
            {
                if(E[j][2] > E[j + 1][2])
                {
                    int a = E[j][0];
                    int b = E[j][1];
                    int c = E[j][2];
                    E[j][0] = E[j + 1][0];
                    E[j][1] = E[j + 1][1];
                    E[j][2] = E[j + 1][2];
                    E[j + 1][0] = a;
                    E[j + 1][1] = b;
                    E[j + 1][2] = c;
                }
            }

        }

        for(int l = 0; l < A; l++)
        {
            U[l] = l;
        }

        for(int i = 0; i < A - 1; i++)
        {
            for(int j = 0; j < 3; j++)
            {
                F[i][j] = -1;
            }

        }

        while(edge_number < A - 1) 
        {
            int a = E[edge_next][0];
            int b = E[edge_next][1];
            int random = a;
            int random1;
            for(random1 = random; U[random1] != random1; random1 = U[random1]) { }
            int i = random1;
            int r = b;
            int z;
            for(z = r; U[z] != z; z = U[z]) { }
            int j = z;
            if(equal(i, j) == 0)
            {
                if(i < j)
                {
                    U[j] = i;
                } else
                {
                    U[i] = j;
                }
                F[edge_number][0] = E[edge_next][0];
                F[edge_number][1] = E[edge_next][1];
                F[edge_number][2] = E[edge_next][2];
                edge_number++;
            }
            edge_next++;
        }
        FileOutputStream FOS = null;
        try
        {
            File file = new File("graph.out");
            FOS = new FileOutputStream(file);
            if(!file.exists())
            {
                try
                {
                    file.createNewFile();
                }
                catch(IOException e)
                {
                    e.printStackTrace();
                }
            }
        }
        catch(FileNotFoundException e)
        {
            e.printStackTrace();
        }
        PrintStream PS = new PrintStream(FOS);
        for(int i = 0; i < A - 1; i++)
        {
            int random2 = F[i][0];
            int random3 = F[i][1];
            if(random2 > random3)
            {
            	PS.println(out[random3][random2]);
            } else
            {
            	PS.println(out[random2][random3]);
            }
        }

    }

    static int equal(int p, int q)
    {
        return p != q ? 0 : 1;
    }

}
